package lbl.akenti.disp;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import lbl.akenti.gen.common.HtmlCertWriter;
import lbl.akenti.gen.controller.WrapUtil;
import lbl.akenti.messaging.CertificateInfo;

public class CertInfoViewFrame
extends JFrame implements ActionListener {
  private JLabel certificateLabel;
  private JLabel mesg;
  private CertificateInfo certInfo;
  private JButton closeButton;
  
  public CertInfoViewFrame(CertificateInfo c) {
    super(c.toString());
    certInfo = c;
    
    if (certInfo.getAkentiMessages().length == 0) {
      mesg = new JLabel("");
    } else {
      StringBuffer buffer = new StringBuffer();
      for (int i=0; i < certInfo.getAkentiMessages().length; i++) {
        buffer.append(certInfo.getAkentiMessages()[i].getMessage());
        buffer.append("/n");
      }
      
      mesg = new JLabel(buffer.toString());
    }
    mesg.setBackground(Color.yellow);
    mesg.setOpaque(true);
    
    certificateLabel = new JLabel(certInfo.toString(), JLabel.LEFT);
    certificateLabel.setBackground(Color.white);
    certificateLabel.setOpaque(true);
    certificateLabel.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
    
    JScrollPane sPane =  new JScrollPane(certificateLabel);
    
    sPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    sPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
    sPane.setPreferredSize(new Dimension(400, 350));
    
    JPanel infoPane = WrapUtil.wrapVertical(mesg, sPane);
    
    closeButton = new JButton("Close");
    closeButton.setEnabled(true);
    closeButton.setActionCommand("Close");
    closeButton.addActionListener(this);
    
    JPanel certRespPane = new JPanel();
    
    JPanel buttonPanel = new JPanel();
    buttonPanel.setLayout(new FlowLayout());
    buttonPanel.add(closeButton);
    
    certRespPane = WrapUtil.wrapVertical(infoPane, buttonPanel);
    
    getContentPane().add(certRespPane, "Center");
    certificateLabel.setText(new HtmlCertWriter().toHtml(certInfo.getAkentiCertificate()));
    setLocation(100, 100);
  }
  
  public CertificateInfo getCertInfo() {
    return certInfo;
  }
  
  public void actionPerformed(ActionEvent event) {
    String cmd = event.getActionCommand();
    
    if (cmd.equals("Close")) {
      setVisible(false);
    } else {
      throw new RuntimeException(cmd + " not supported");
    }
  }
    
  public boolean equals(Object o) {
    return certInfo.getAkentiCertificate() == ((CertInfoViewFrame)o).getCertInfo().getAkentiCertificate();
  }
  
  public int hashCode() {
    return certInfo.getAkentiCertificate().getUniqueID().hashCode();
  }
}