package lbl.akenti.gen.controller.attr;

import javax.swing.JPanel;
import javax.swing.event.DocumentListener;
import javax.swing.event.DocumentEvent;

import lbl.akenti.gen.controller.LBLFrame;
import lbl.akenti.gen.controller.LBLPrincipalPane;

import lbl.akenti.certs.elements.AkentiPrincipal;
import lbl.akenti.util.ParsingException;

/**
  *
  */
public 
class AtUserFrame  
  extends LBLFrame
  implements DocumentListener {

  private LBLPrincipalPane principalPane;

  /** 
    * Builds this frame.
    *
    */
  public AtUserFrame(String title, String instructions) {
    super(title, instructions);

    JPanel contentPane = (JPanel) getContentPane();

    principalPane = new LBLPrincipalPane(null);
    principalPane.setDocumentListener(this);
    contentPane.add(principalPane, "Center");
    doEnable();
  }

  /**
    */
  public void changedUpdate(DocumentEvent e)  {
    doEnable();
  }

  /**
    */
  public void insertUpdate(DocumentEvent e)  {
    doEnable();
  }

  /**
    */
  public void removeUpdate(DocumentEvent e) {
    doEnable();
  }

  public AkentiPrincipal getAkentiPrincipal() {
    try {
      return principalPane.getAkentiPrincipal();
    } catch(ParsingException ex) {
      return null;
    }
  }

  /**
    */
  private void doEnable() {
    if (getAkentiPrincipal() != null) {
      enableBlueButton("Next");
    } else {
      disableBlueButton("Next");
    }
  }

  /**
    */
  public void clear() {
    principalPane.clear();
  }
}
