package lbl.akenti.gen.controller.pol;

import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.event.ListDataListener;
import javax.swing.event.ListDataEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import lbl.akenti.gen.controller.LBLFrame;
import lbl.akenti.gen.controller.LBLDirPane;
import lbl.akenti.certs.elements.Directory;

/**
  * Allows the user to build and edit attribute directories.
  *
  * 
  * @see lbl.akenti.gen.controller.LBLFrame
  * @see lbl.akenti.gen.controller.LBLDirPane
  */
public class PolAttrDirsFrame 
  extends LBLFrame implements ListDataListener {

  private LBLDirPane dirPane;

  /** 
    * Builds the frame. 
    *
    * @param title title of the frame
    * @param instructions to be displayed at top of frame  
    */
  public PolAttrDirsFrame (String title, String instructions) {
    super(title, instructions);
    
    dirPane = new LBLDirPane(
      "Attribute Directories",
      new String[] { "http", "file" }
    );
    
    dirPane.setListDataListener(this);

    JPanel contentPane = (JPanel) getContentPane();

    contentPane.add(dirPane, "Center");
    enableBlueButton("Next");
  }

  /**
    */
  public void contentsChanged(ListDataEvent e) {
    doEnable();
  }

  /**
    */
  public void intervalAdded(ListDataEvent e) {
    doEnable();
  }

  /**
    */
  public void intervalRemoved(ListDataEvent e)  {
    doEnable();
  }
  
  /**
    */
  void doEnable() {
  }

  /**
    */
  public Directory[] getAttrDirs() {
    return dirPane.getDirs();
  }

  /**
    */
  public void addAttrDir(Directory dir) {
    dirPane.addDir(dir);
  }

  public void addAttrDirs(Directory[] dirs) {
    dirPane.addDirs(dirs);
  }

  /**
    */
  public void clear() {
    dirPane.clear();
  }
}
