package lbl.akenti.messaging;

import java.io.IOException;
import java.text.ParseException;

import javax.xml.bind.JAXBException;
import lbl.akenti.jaxb.AkentiResponseType;

/**
  */
abstract public
class AkentiResponse {
  private int id;
  private AkentiMessage mesg;

  /**
    */
  protected  AkentiResponse(int id, AkentiMessage mesg) {
    if (id < 0 || mesg == null) {
      throw new IllegalArgumentException();
    }

    this.mesg = mesg;
    this.id = id;
  }

  /**
    */
  public int getID() {
    return id;
  }

  /**
    */
  public AkentiMessage getMessage() {
    return mesg;
  }

  /**
    */
  final AkentiResponseType toJAXBImpl() throws JAXBException {
    AkentiResponseType impl = doToJAXBImpl();
 
    impl.setID(getID());
    impl.setAkentiMessage(getMessage().toJAXBImpl());
    return impl;
  }
 
  /**
    */
  abstract protected AkentiResponseType doToJAXBImpl() throws JAXBException;

  /**
    * FOR XML STUFF
    */
  AkentiResponse(AkentiResponseType impl) {
    id = impl.getID();
    mesg = new AkentiMessage(impl.getAkentiMessage());
  }
}
