package lbl.akenti.messaging;

import javax.xml.bind.JAXBException;
import lbl.akenti.jaxb.CheckPolicyRequestType;
import lbl.akenti.jaxb.AkentiRequestType;

final public
class CheckPolicyRequest extends AkentiRequest {
  private String resource;

  /**
    */
  public CheckPolicyRequest(int uid, String resource) {
    super(uid);

    if (resource.length() == 0) {
      throw new IllegalArgumentException();
    }

    this.resource = resource;
  }

  /**
    */
  public String getResource() {
    return resource;
  }

  /**
    * USED FOR DOING XML STUFF 
    */
  CheckPolicyRequest(CheckPolicyRequestType impl) {
    super(impl);
    resource = impl.getResource();
  }
  
  /**
    * USED FOR DOING XML STUFF 
    */
  protected AkentiRequestType doToJAXBImpl(boolean type) throws JAXBException {
    CheckPolicyRequestType impl = type? Util.getObjectFactory().createCheckPolicyRequestType()
                                          : Util.getObjectFactory().createCheckPolicyRequestGenerated();

    impl.setResource(getResource());
    return impl;
  }
}
