package lbl.akenti.messaging;

import javax.xml.bind.JAXBException;
import lbl.akenti.jaxb.CreateResourceRequestType;
import lbl.akenti.jaxb.AkentiRequestType;

final public
class CreateResourceRequest extends AkentiRequest {
  private String resource;

  /**
   * Used to request the creation of a (non-root) resource. 
   *
   * @author Tommaso Sciortino
   **/
  public CreateResourceRequest(int uid, String resource) {
    super(uid);

    if (resource.length() == 0) {
      throw new IllegalArgumentException();
    }

    this.resource = resource;
  }

  /**
    */
  public String getResource() {
    return resource;
  }

  /**
    * USED FOR DOING XML STUFF 
    */
  CreateResourceRequest(CreateResourceRequestType impl) {
    super(impl);
    resource = impl.getResource();
  }
  
  /**
    * USED FOR DOING XML STUFF 
    */
  protected AkentiRequestType doToJAXBImpl(boolean type) throws JAXBException {
    CreateResourceRequestType impl = type? Util.getObjectFactory().createCreateResourceRequestType()
                                           : Util.getObjectFactory().createCreateResourceRequestGenerated();

    impl.setResource(getResource());
    return impl;
  }
}
