package lbl.akenti.messaging;

import javax.xml.bind.JAXBException;
import lbl.akenti.jaxb.CreateResourceResponseType;
import lbl.akenti.jaxb.AkentiResponseType;

/**
 * An sparse response to a create resource request.
 * Empty except for the AkentiMessage.
 *
 * @author Tommaso Sciortino
 */
final public
class CreateResourceResponse extends AkentiResponse {
  
  /**
   * Constructs a <i>CreateResourceResponse</i>.
   *
   * @param ap the DN/CADN pair of an entity.
   * @param resource name of a resource
   * @see AkentiPrincipal
   */
  public CreateResourceResponse(int uid, AkentiMessage mesg) {
    super(uid, mesg);
  }
  
  /**
   * USED FOR DOING XML STUFF
   */
  public CreateResourceResponse(CreateResourceResponseType impl) {
    super(impl);
  }
  
  /**
   * USED FOR DOING XML STUFF
   */
  protected AkentiResponseType doToJAXBImpl() throws JAXBException {
    return Util.getObjectFactory().createCreateResourceResponseGenerated();
  }
}
