package lbl.akenti.parsers;

/**
  * Class defines the various token types that
  * makes up an <code>Expression</code>.
  *
  * Values of <i>TokenType</i> are: <br>
  * <blockquote>
  *    "CONST",   <br>
  *    "AND",     <br>
  *    "OR",      <br>
  *    "NOT",     <br>
  *    "LPAREN",  <br>
  *    "RPAREN",  <br>
  *    "GR",      <br> 
  *    "GRE",     <br>
  *    "LT",      <br>
  *    "LTE",     <br>
  *    "EQ",      <br>
  *    "NEQ",     <br> 
  *    "INVALID"  <br> 
  * </blockquote>
  *
  * @version 1.1 07/01/2003 
  * @author Abdelilah Essiari
  */
public interface TokenType {
  public static int CONST = 0;
  public static int AND = 1;
  public static int OR = 2;
  public static int NOT = 3;
  public static int LPAREN = 4;
  public static int RPAREN = 5;
  public static int GT = 6;
  public static int GTE = 7;
  public static int LT = 8;
  public static int LTE = 9;
  public static int EQ = 10;
  public static int NEQ = 11;
  public static int INVALID = 12;
  public static int ENULL = 13;

  public static String AND_STRING = "&&";
  public static String OR_STRING = "||";
  public static String NOT_STRING = "!";
  public static String LPAREN_STRING = "(";
  public static String RPAREN_STRING = ")";
  public static String GT_STRING = ">";
  public static String GTE_STRING = ">=";
  public static String LT_STRING = "<";
  public static String LTE_STRING = "<=";
  public static String EQ_STRING = "=";
  public static String NEQ_STRING = "!=";
  public static String INVALID_STRING = "";
}
