package lbl.akenti.policyEngine;

import lbl.akenti.certs.PolicyCertificate;
import lbl.akenti.certs.UseCondCertificate;

/**
  * Groups the <i>PolicyCertificate</i> and the <i>UseConditionCertificate</i>s
  * that apply to the same resource.<BR>
  *
  * @author Abdelilah Essiari.
  * @see lbl.akenti.certs.PolicyCertificate
  * @see lbl.akenti.certs.UseCondCertificate
  */
public 
interface ResourcePolicy {

  /**
    */
  public String getResource();

  /**
    * @see lbl.akenti.certs.PolicyCertificate
    */
  public PolicyCertificate getPolicyCertificate();

  /**
    * @see lbl.akenti.certs.UseCondCertificate
    */
  public UseCondCertificate[] toUseCondCertificates();

}
