package lbl.akenti.policyManager.widgets;

import java.util.ArrayList;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Container;
import java.awt.BorderLayout;
import java.awt.Component;

import java.awt.print.Printable;
import java.awt.print.PrinterJob;
import java.awt.print.PrinterException;
import java.awt.print.PageFormat;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JScrollPane;
import javax.swing.JPanel;
import javax.swing.JEditorPane;
import javax.swing.ImageIcon;
import javax.swing.JInternalFrame;
import javax.swing.JList;
import javax.swing.ListSelectionModel;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkEvent.EventType;
import javax.swing.event.HyperlinkListener;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JMenu;
import javax.swing.KeyStroke;
import javax.swing.JSplitPane;

import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeSelectionEvent;

import java.io.IOException;

import java.net.URL;

public class ACMHelpMenu extends JInternalFrame implements TreeSelectionListener, Printable, ActionListener {
    
    private JEditorPane text;
    private JList helpList;
    private JTree tree;
    private Component printComponent;
    
    private ClassLoader loader = Thread.currentThread().getContextClassLoader();
    
    
    private static final int WIDTH = 1000;
    private static final int HEIGHT = 600;
    
    
    
    public static void main(String[] args) {
        //      ACMHelpMenu frame = new ACMHelpMenu();
        //    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        //  frame.show();
    }
    
    public ACMHelpMenu() {
        
        super("Akenti Certificate Manager Help",
        true, //resizable
        true, //closable
        true, //maximizable
        true);//iconifiable
        
        JMenuBar menuBar = new JMenuBar();
        JMenu printMenu = new JMenu("Print");
        printMenu.setMnemonic(KeyEvent.VK_P);
        menuBar.add(printMenu);
        
        JMenuItem printItem = new JMenuItem("Print Contents");
        printItem.setMnemonic(KeyEvent.VK_C);
        printItem.setAccelerator(KeyStroke.getKeyStroke(
        KeyEvent.VK_C, ActionEvent.ALT_MASK));
        printItem.setActionCommand("print");
        printItem.addActionListener(this);
        printMenu.add(printItem);
        
        setJMenuBar(menuBar);
        
        tree = new JTree(buildTree());
        tree.addTreeSelectionListener(this);
        
        Container contentPane = getContentPane();
        contentPane.setLayout(new BorderLayout(0, 10));
        //contentPane.add(new JScrollPane(tree), BorderLayout.WEST);
        text = new JEditorPane();
        text.setEditable(false);
        text.setContentType("text/html");
        JScrollPane textScrollPane = new JScrollPane(text);
        textScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        
        // set starting text and icon
        if (loader == null) { // there may not be a context class loader
            loader = ACMHelpMenu.class.getClassLoader();
        }
        try {
            text.setPage(loader.getResource("lbl/akenti/policyManager/docs/index.html"));
        }
        catch (IOException ex) {
            ex.printStackTrace();
        }
        
        text.addHyperlinkListener(new
        HyperlinkListener() {
            public void hyperlinkUpdate(HyperlinkEvent event) {
                
                // if user clicks on the link
                if (event.getEventType() == EventType.ACTIVATED) {
                    try {
                        text.setPage(event.getURL());
                    }
                    catch (IOException e) {
                        e.printStackTrace();
                    }
                    
                }
            }
            
        });
        
        //Create a split pane with the two scroll panes in it.
        JSplitPane splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,
        new JScrollPane(tree), textScrollPane);
        splitPane.setOneTouchExpandable(true);
        splitPane.setDividerLocation(300);
        
        contentPane.add(splitPane, BorderLayout.CENTER);
        
    }
    
    public DefaultMutableTreeNode buildTree() {
        // set up tree model data
        
        DefaultMutableTreeNode root
        = new DefaultMutableTreeNode("Akenti Certificate Manager Help");
        
        DefaultMutableTreeNode certManagerParent
        = new DefaultMutableTreeNode("Certificate Manager");
        
        root.add(certManagerParent);
        
        DefaultMutableTreeNode certManagerChild
        = new DefaultMutableTreeNode("Akenti Certificate Manager");
        certManagerParent.add(certManagerChild);
        
        DefaultMutableTreeNode generatorParent = new DefaultMutableTreeNode("Certificate Generators");
        root.add(generatorParent);
        
        DefaultMutableTreeNode polChild = new DefaultMutableTreeNode("Policy Certificate Generator");
        generatorParent.add(polChild);
        
        DefaultMutableTreeNode ucChild = new DefaultMutableTreeNode("Use Condition Certificate Generator");
        generatorParent.add(ucChild);
        
        DefaultMutableTreeNode attrChild = new DefaultMutableTreeNode("Attribute Certificate Generator");
        generatorParent.add(attrChild);
        
        return root;
    }
    
    public void valueChanged(TreeSelectionEvent e) {
        String selection = e.getPath().getLastPathComponent().toString();
        
        if (selection.equals("Akenti Certificate Manager Help")) {
            if (loader == null) { // there may not be a context class loader
                loader = ACMHelpMenu.class.getClassLoader();
            }
            try {
                text.setPage(loader.getResource("lbl/akenti/policyManager/docs/index.html"));
            }
            catch (IOException ex) {
                ex.printStackTrace();
            }
        }
        else if (selection.equals("Akenti Certificate Manager")) {
            if (loader == null) { // there may not be a context class loader
                loader = ACMHelpMenu.class.getClassLoader();
            }
            try {
                text.setPage(loader.getResource("lbl/akenti/policyManager/docs/manager/manager.html"));
            }
            catch (IOException ex) {
                ex.printStackTrace();
            }
            
        }
        else if (selection.equals("Policy Certificate Generator")) {
            if (loader == null) { // there may not be a context class loader
                loader = ACMHelpMenu.class.getClassLoader();
            }
            try {
                
                text.setPage(loader.getResource("lbl/akenti/policyManager/docs/pol/pol.html"));
            }
            catch (IOException ex) {
                ex.printStackTrace();
            }
            
        }
        else if (selection.equals("Use Condition Certificate Generator")) {
            if (loader == null) { // there may not be a context class loader
                loader = ACMHelpMenu.class.getClassLoader();
            }
            try {
                text.setPage(loader.getResource("lbl/akenti/policyManager/docs/uc/uc.html"));
            }
            catch (IOException ex) {
                ex.printStackTrace();
            }
            
        }
        else if (selection.equals("Attribute Certificate Generator")) {
            if (loader == null) { // there may not be a context class loader
                loader = ACMHelpMenu.class.getClassLoader();
            }
            
            
            //System.out.println("TESTING");
            //System.out.println(ACMHelpMenu.class.getResource("lbl/akenti/policyManager/docs/attr/attr.html"));
            try {
                text.setPage(loader.getResource("lbl/akenti/policyManager/docs/attr/attr.html"));
            } catch (IOException ex) {
                ex.printStackTrace();
            }
            
            
        }
    }
    
    public void actionPerformed(ActionEvent e) {
        if (e.getActionCommand().equals("print")) {
            printout(text);
        }
    }
    
    public void printout(Component aPrintComponent) {
        
        printComponent = aPrintComponent;
        PrinterJob printJob = PrinterJob.getPrinterJob();
        printJob.setPrintable(this);
        if (printJob.printDialog()) {
            try {
                printJob.print();
            } catch (PrinterException pe) {
                System.out.println("Error printing: " + pe);
            }
        }
    }
    
    public int print(Graphics g, PageFormat pageFormat, int pageIndex) {
        if (pageIndex > 0) {
            
            return(NO_SUCH_PAGE);
        }
        else {
            Graphics2D g2d = (Graphics2D)g;
            g2d.translate(pageFormat.getImageableX(), pageFormat.getImageableY());
            printComponent.paint(g2d);
            return(PAGE_EXISTS);
        }
    }
    
}
