package lbl.akenti.policyManager.widgets;

import java.awt.Graphics;
import java.awt.Container;
import java.awt.BorderLayout;

import javax.swing.JScrollPane;
import javax.swing.JPanel;
import javax.swing.JEditorPane;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.ListSelectionModel;
import javax.swing.JList;

import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkEvent.EventType;
import javax.swing.event.HyperlinkListener;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.ListSelectionEvent;

import java.util.ArrayList;


import java.io.IOException;

import java.net.URL;

public class HTMLMenuMaker extends JInternalFrame {
    
    private JEditorPane textPane;
    private JList helpList;
    private static final int WIDTH = 1000;
    private static final int HEIGHT = 600;
    
    public HTMLMenuMaker(String title, String url) {
        
        super(title,
        true, //resizable
        true, //closable
        true, //maximizable
        true);//iconifiable
        
        Container contentPane = getContentPane();
        textPane = new JEditorPane();
        textPane.setEditable(false);
        textPane.setContentType("text/html");
        JScrollPane textScrollPane = new JScrollPane(textPane);
        textScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        
        // set starting page
        try {
            textPane.setPage(new URL(url));
        }
        catch (IOException e) {}
        
        textPane.addHyperlinkListener(new
        HyperlinkListener() {
            public void hyperlinkUpdate(HyperlinkEvent event) {
                
                // if user clicks on the link
                if (event.getEventType() == EventType.ACTIVATED) {
                    try {
                        textPane.setPage(event.getURL());
                    }
                    catch (IOException e) {
                        e.printStackTrace();
                    }
                    
                }
            }
            
        });
        
        contentPane.add(textScrollPane, BorderLayout.CENTER);
        
    }
    
}