package lbl.akenti.policyManager.widgets;

import java.util.Properties;

import com.sun.net.ssl.HostnameVerifier;
import com.sun.net.ssl.KeyManagerFactory;
import com.sun.net.ssl.TrustManagerFactory;
import com.sun.net.ssl.SSLContext;
import com.sun.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLSocketFactory;
import javax.net.ssl.SSLSession;
import javax.net.SocketFactory;
import java.security.KeyStore;
import java.security.SecureRandom;
import java.security.cert.X509Certificate;
import java.security.GeneralSecurityException;
import java.net.MalformedURLException;
import java.net.URLConnection;
import java.net.URL;
import java.util.Properties;
import java.io.FileInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import lbl.akenti.util.X509CertReader;

class SSLInfo {
    public static void
    initSSLInfo(String p12FileName, char[] password, String casFileName)
    throws IOException, GeneralSecurityException {
        KeyStore ks = KeyStore.getInstance("PKCS12");
        
        ks.load(new FileInputStream(p12FileName), password);
        
        X509CertReader xcr = new X509CertReader();
        X509Certificate[] caCerts = xcr.readX509Certs(casFileName);
        
        for (int i = 0; i < caCerts.length; ++i) {
            String alias = caCerts[i].getSubjectDN().toString();
            
            ks.setCertificateEntry(alias, caCerts[i]);
        }
        
        KeyManagerFactory kfac = KeyManagerFactory.getInstance("SunX509");
        
        kfac.init(ks, password);
        
        TrustManagerFactory tfac = TrustManagerFactory.getInstance("SunX509");
        
        tfac.init(ks);
        
        SSLContext ctx = SSLContext.getInstance("SSLv3");
        File f = new File(".rand");
        byte seed[] = null;
        
        try {
            if (f.exists()) {
                FileInputStream fis = new FileInputStream(f);
                byte temp[] = new byte[20];
                
                fis.read(temp);
                seed = temp;
            }
        } catch(IOException ex) {
            // DO NOTHING
        }
        
        SecureRandom random = SecureRandom.getInstance("SHA1PRNG");
        
        if (seed == null) {
            System.out.println("this will take some time...");
            seed = random.generateSeed(20);
            
            try {
                FileOutputStream fos = new FileOutputStream(f);
                fos.write(seed);
                fos.flush();
                fos.close();
                
                System.out.println("A .rand file is saved into this directory");
                
            } catch(IOException ex) {
            }
        } else {
            random.setSeed(seed);
        }
        
        ctx.init(
        kfac.getKeyManagers(),
        tfac.getTrustManagers(),
        random
        );
        
        SSLSocketFactory sslFactory = ctx.getSocketFactory();
        HttpsURLConnection.setDefaultSSLSocketFactory(sslFactory);
        
        HttpsURLConnection.setDefaultHostnameVerifier(new HostnameVerifier() {
            public boolean verify(String urlHostname, String string) {
                return true;
            }
        });
    }
}

