/**
 * @author Cay S. Horstmann
 * @see http://www.horstmann.com
 */

package lbl.akenti.policyManager.widgets;

import javax.swing.JOptionPane;
import java.util.StringTokenizer;

public class VersionChecker {

    public static final String JAVA_VERSION = "1.4";
    
    public static boolean checkJavaVersion() {
    
        String version = System.getProperty("java.version");
        boolean versionOk;
        try {
            versionOk = versionCompare(version, JAVA_VERSION) >= 0;
            
        }
        catch (NumberFormatException exception) {
            versionOk = false;
        }
        if (!versionOk) {
            JOptionPane.showMessageDialog(null,
            "You need Java version " + JAVA_VERSION);
            return false;
        }
        else {
            return true;
        }
        
    }
    
    public static int versionCompare(String v1,String v2) {
        StringTokenizer t1 = new StringTokenizer(v1, "._");
        StringTokenizer t2 = new StringTokenizer(v2, "._");
        while (t1.hasMoreTokens()) {
            if (!t2.hasMoreTokens()) return 1;
            int n1 = Integer.parseInt(t1.nextToken());
            int n2 = Integer.parseInt(t2.nextToken());
            int d = n1 - n2;
            if (d != 0) return d;
        }
        return t2.hasMoreTokens() ? -1 : 0;
    }
    
    
}
