package lbl.akenti.policyManager.widgets.attr;

import javax.swing.JPanel;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import lbl.akenti.policyManager.widgets.LBLTopFrame;
import lbl.akenti.policyManager.widgets.LBLAttrValPane;

import lbl.akenti.policyManager.base.GenAttribute;
import lbl.akenti.policyManager.base.GenValue;

import lbl.akenti.policyManager.widgets.LBLPanel;

public class AtValuePanel extends LBLPanel implements DocumentListener {
    
    private LBLAttrValPane attrValPane;
    
    /**
     *
     */
    public AtValuePanel(LBLTopFrame parent, String header) {
        super(parent, header);
        
        attrValPane = new LBLAttrValPane(null, true);
        attrValPane.setDocumentListener(this);
        add(
        attrValPane,
        "Center"
        );
        
        doEnable();
    }
    
    /*
     * Adds an Attribute.
     */
    public void addAttribute(GenAttribute attribute) {
        attrValPane.addAttribute(attribute);
    }
    
    /**
     */
    public void changedUpdate(DocumentEvent e)  {
        doEnable();
    }
    
    /**
     */
    public void insertUpdate(DocumentEvent e)  {
        doEnable();
    }
    
    /**
     */
    public void removeUpdate(DocumentEvent e) {
        doEnable();
    }
    
    /**
     */
    public void doEnable() {
        if (getAttributeName().equals("")) {
            doEnable(false);
            return;
        } else if (getValueName().equals("")) {
            doEnable(false);
        } else {
            doEnable(true);
        }
    }
    
    /**
     *
     */
    private void doEnable(boolean enable) {
        if (enable) {
            enableBlueButton("Next");
        } else {
            disableBlueButton("Next");
        }
    }
    
    /**
     */
    public GenValue getGenValue() {
        return attrValPane.getGenValue();
    }
    
    public GenAttribute getGenAttribute() {
        return attrValPane.getGenAttribute();
    }
    
    /**
     */
    public String getAttributeName() {
        return attrValPane.getAttributeName();
    }
    
    /**
     */
    public String getValueName() {
        return attrValPane.getValueName();
    }
    
    /**
     */
    public void clear() {
        doEnable(); // added 5-7-04 to turn off the Next button when this panel is first displayed
        attrValPane.clear();
    }
}

