package lbl.akenti.policyManager.widgets.pol;

import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.event.ListDataListener;
import javax.swing.event.ListDataEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import lbl.akenti.policyManager.widgets.LBLPanel;
import lbl.akenti.policyManager.widgets.LBLDirPane;
import lbl.akenti.certs.elements.Directory;

import lbl.akenti.policyManager.widgets.LBLTopFrame;

/**
 * Allows the user to build and edit attribute directories.
 *
 *
 * @see lbl.akenti.policyManager.widgets.LBLFrame
 * @see lbl.akenti.policyManager.widgets.LBLDirPane
 */
public class PolAttrDirsPanel
extends LBLPanel implements ListDataListener {
    
    private LBLDirPane dirPane;
    
    /**
     * Builds the frame.
     *
     * @param title title of the frame
     * @param instructions to be displayed at top of frame
     */
    public PolAttrDirsPanel(LBLTopFrame parent, String header) {
        super(parent, header);
        
        dirPane = new LBLDirPane(
        "Attribute Directories",
        new String[] { "http", "file" }
        );
        
        dirPane.setListDataListener(this);
        
        add(dirPane, "Center");
        enableBlueButton("Next");
    }
    
    /**
     */
    public void contentsChanged(ListDataEvent e) {
    }
    
    /**
     */
    public void intervalAdded(ListDataEvent e) {
    }
    
    /**
     */
    public void intervalRemoved(ListDataEvent e)  {
    }
    
    /**
     */
    public void doEnable() {
    }
    
    /**
     */
    public Directory[] getAttrDirs() {
        return dirPane.getDirs();
    }
    
    /**
     */
    public void addAttrDir(Directory dir) {
        dirPane.addDir(dir);
    }
    
    public void addAttrDirs(Directory[] dirs) {
        dirPane.addDirs(dirs);
    }
    
    /**
     */
    public void clear() {
        dirPane.clear();
    }
}
