package lbl.akenti.policyManager.widgets.pol;

import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import javax.swing.BorderFactory;
import javax.swing.border.Border;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.BorderLayout;
import java.awt.Color;

import lbl.akenti.policyManager.widgets.WrapUtil;
import lbl.akenti.policyManager.widgets.LBLDialogFactory;
import lbl.akenti.policyManager.widgets.LBLButtonPanel;
import lbl.akenti.policyManager.widgets.LBLDirPane;
import lbl.akenti.policyManager.widgets.LBLLdapPanel;


/**
 *
 */
public
class X509CertsPanel
extends JOptionPane
implements ActionListener{
    
    private static final Color B_COLOR = new Color(255, 255, 204);
    
    private JTextArea certArea;
    
    private JButton okButton = new JButton("OK");
    
    /**
     * Builds this frame.
     *
     */
    public X509CertsPanel() {
        this(null);
    }
    
    /**
     * Builds this frame.
     *
     */
    public X509CertsPanel(String instructions) {
        setLayout(new BorderLayout(5, 5));
        
        Border border = BorderFactory.createEmptyBorder(5, 5, 5, 5);
        
        setBorder(border);
        
        if (instructions != null) {
            JLabel label = new JLabel(instructions);
            
            border = BorderFactory.createCompoundBorder(
            BorderFactory.createLineBorder(Color.black, 3),
            border
            );
            
            label.setBorder(border);
            label.setBackground(B_COLOR);
            label.setOpaque(true);
            add(label, "North");
        }
        
        certArea = new JTextArea();
        add(new JScrollPane(certArea), "Center");
        JPanel buttonPanel = new JPanel();
        
        okButton.setActionCommand("ok");
        okButton.addActionListener(this);
        buttonPanel.add(okButton);
        add(buttonPanel, "South");
    }
    
    /**
     */
    public void setCerts(String[] certs) {
        certArea.setText("");
        
        for (int i = 0; i < certs.length; ++i) {
            certArea.append(certs[i]);
        }
    }
    
    /**
     */
    public void actionPerformed(ActionEvent e) {
        String cmd = e.getActionCommand();
        
        if (cmd.equals("ok")) {
            setValue(new Integer(OK_OPTION));
        } else {
            throw new RuntimeException(cmd + " not supported");
        }
    }
}
