package lbl.akenti.remotePolicyEngine;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Writer;
import java.text.ParseException;
import lbl.akenti.jaxb.AkentiRequestType;
import lbl.akenti.messaging.AkentiRequest;
import lbl.akenti.messaging.AkentiResponses;
import lbl.akenti.messaging.Util;
import lbl.akenti.util.XMLUtil;
import org.apache.soap.rpc.SOAPContext;
import org.apache.soap.util.Bean;
import org.apache.soap.util.xml.Deserializer;
import org.apache.soap.util.xml.NSStack;
import org.apache.soap.util.xml.QName;
import org.apache.soap.util.xml.Serializer;
import org.apache.soap.util.xml.XMLJavaMappingRegistry;
import org.w3c.dom.Element;
import org.w3c.dom.Node;


public class 
AkentiMessagingSerializer implements Serializer, Deserializer {

  private static boolean DEBUG = true; 

  public void 
  marshall(String inScopeEncStyle,
                  Class javaType,
                  Object src,
                  Object context,
                  Writer sink,
                  NSStack nsStack,
                  XMLJavaMappingRegistry xjmr,
                  SOAPContext ctx) throws IllegalArgumentException, IOException {
try {
    AkentiRequest request = (AkentiRequest) src;
    AkentiRequestType type = request.toJAXBImpl(true);

    if (DEBUG) {
      Util.marshal(type, System.err); 
    }

    ByteArrayOutputStream baos = new ByteArrayOutputStream();

    Util.marshal(type, baos); 

    ByteArrayInputStream bais = new ByteArrayInputStream(baos.toByteArray());
    BufferedReader reader = new BufferedReader(new InputStreamReader(bais));
    // TODO: HACKING AWAY JUST TO REMOVE THIS FIRST LINE
    // NEEDS TO FIND A WAY  TO WRITE A NODE WITHOUT THAT ANNOYING DECLARATION LINE
    reader.readLine();

    String line;
    String className = request.getClass().getName();

    className = className.substring("lbl.akenti.messaging.".length());
 
    sink.write("<ns1:" + className + ">\n");
    while ((line = reader.readLine()) != null) {
      sink.write(line + "\n");
    }
    
    sink.write("</ns1:" + className + ">");
    sink.flush();
} catch(Exception ex) {
    if (DEBUG) {
      ex.printStackTrace();
    }

    throw new IllegalArgumentException(ex.getMessage());
}
  }
  
  public Bean 
  unmarshall(String inScopeEncStyle,
             QName elementType,
             Node src,
             XMLJavaMappingRegistry xjmr,
             SOAPContext ctx) throws IllegalArgumentException {
    try {
      if (DEBUG) {
        XMLUtil.writeDocument(((Element) src).getOwnerDocument(), System.err);
      }

      AkentiResponses responses = new AkentiResponses((Element) src);

      return new Bean(AkentiResponses.class, responses);
    } catch(IOException ex) {
      if (DEBUG) {
        ex.printStackTrace();
      }

      throw new IllegalArgumentException(ex.getMessage());
    } catch(ParseException ex) {
      if (DEBUG) {
        ex.printStackTrace();
      }

      throw new IllegalArgumentException(ex.getMessage());
    }
  }
}
