package lbl.akenti.servers.AKMonitor.gui;

/**
  * StatusCanvas.java
  * by Abdelilah Essiari
  *
  **/

import javax.swing.JPanel;
import javax.swing.border.BevelBorder;
import java.awt.Dimension;
import java.awt.Color;

public class StatusCanvas extends JPanel {
  protected static Dimension defaultDimension = new Dimension(7, 7);
  protected StatusEvent event;

  public StatusCanvas(StatusEvent event) {
    statusCanvasInit();
    setStatusEvent(event);
  }

  protected void statusCanvasInit() {
    setBorder(new BevelBorder(BevelBorder.RAISED));
    setPreferredSize(defaultDimension);
  }

  public void setStatusEvent(StatusEvent event) {
    this.event = event;
    
    if (event != null) {
      setBackgroundColor();
    }
  }

  public StatusEvent getStatusEvent() {
    return event;
  }
    
  public void setBackgroundColor() {
    switch (event.getStatus()) {
      case StatusEvent.SUCCESS:
        setBackground(Color.green);
        break;
      case StatusEvent.FAILURE:
        setBackground(Color.yellow);
        break;
      case StatusEvent.DENIED:
        setBackground(Color.red);
        break;
      case StatusEvent.OK:
      case StatusEvent.PENDING:
      default:
        setBackground(Color.lightGray);
        break;
    }
  } 
  
  public Dimension getMinimumSize() {
    return getPreferredSize();
  }

  public Dimension getMaximumSize() {
    return getPreferredSize();
  }

  public Dimension getSize() {
    return getPreferredSize();
  }
}
