package lbl.akenti.servers.AKMonitor.util;

/**
  * class to hold the information collected from the Keyfile
  * @author Guillaume Farret
  * @version August 2001
  */
public class AKInfo {
  private String key;
  private String description;
  private String success;
  private String fail;

/**
  * Constructor
  */
  public AKInfo(){}

/**
  * set the key member
  */  
  public void setKey(String key){
    if (key == null) {
      throw new IllegalArgumentException();
    }
  
    this.key = key;
  }

/**
  * return the key member
  */  
  public String getKey(){
    return key;
  }

/**
  * set the description member
  */ 
  public void setDescription(String description) {
    if (description == null) {
      throw new IllegalArgumentException();
    }

    this.description = description;
  }

/**
  * get description member
  */
  public String getDescription() {
    return description;
  }

/**
  * set success member (message displayed if the event is a success)
  */
  public void setSuccess(String success) {
    if (success == null) {
      throw new IllegalArgumentException();
    }

    this.success = success;
  }

/**
  * get success member (message displayed if the event is a success)
  */
  public String getSuccess() {
    return success;
  }

/**
  * set fail member (message displayed if the event is a failure)
  */
  public void setFail(String fail) {
    if (fail == null) {
      throw new IllegalArgumentException();
    }

    this.fail = fail;
  }

/**
  * get fail member (message displayed if the event is a failure)
  */
  public String getFail() {
    return this.fail;
  }
}
