package lbl.akenti.servers.AKMonitor.util;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.Serializable;
import java.io.StringReader;
import java.io.BufferedReader;

import java.util.Hashtable;
import java.util.Enumeration;

/**
  * A class to hold all information about an Akenti event
  * @version August 2001
  */
public class AkentiEvent implements AkentiEventConstants, Serializable  {
  /* Applet needs to know about the different phases of access verification  */
  public int phase;                       
  
  public String key, description, success, fail, message, level;
  public Hashtable table = new Hashtable();              /* used to  attribute-value pairs */
  public int status = OK;
  public int id;

  public AkentiEvent() {}

  public void setKey(String key) { 
    this.key = key; 
  }

  public void setStatus(int status) {
    this.status = status;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public void setFail(String fail) {
    this.fail = fail;
  }
 
  public void setSuccess(String success) {
    this.success = success;
  }
 
  public void setId(int id) {
    this.id = id;
  }
  
  public String toString() {
    StringBuffer buffer = new StringBuffer(); 
    Object name  = table.get("RESOURCE");

    buffer.append(id + "##" + status + "##" + phase + "##" + name + "##" + key + "\n\n");

    if (description != null && status != SUCCESS && status != FAILURE && status != DENIED) {
      buffer.append(description + "\n");
    } else if (success != null && status == SUCCESS) {
      buffer.append(success + "\n");
    } else if (fail != null && (status == FAILURE || status == DENIED)) {
      buffer.append(fail + "\n");
    } 

    if (message != null) {
      buffer.append(message + "\n");
    } 

    Enumeration keys = table.keys(), elements = table.elements();
    
    while (keys.hasMoreElements() == true) {
      buffer.append(keys.nextElement() + " = ");
      buffer.append(elements.nextElement() + "\n");
    }
    return buffer.toString();
  }

  public void fromString(String rep) {
    
    BufferedReader reader = new BufferedReader( new StringReader(rep));
    //StringTokenizer st = reader.readLine();
  

  }




  public void writeToStream(DataOutputStream out) throws IOException {
    String s = this.toString();
    synchronized (out) {
      out.writeInt(s.length());
      out.write(s.getBytes());
    }
  }

  public void readFromStream(DataInputStream in) throws IOException {
    byte[] buffer = new byte[in.readInt()];
    in.readFully(buffer);
    fromString(new String(buffer));
  }
}
