package lbl.akenti.servers.CacheManager;

/**
  *
  **/
public class CacheEntry implements java.io.Serializable {

  private String key;

  private UtcTime notAfter;
  
  private String dirName;

  /**
    *
    */
  public CacheEntry(String key, UtcTime notAfter, String dirName) {
    if (key == null || notAfter == null) {
      throw new IllegalArgumentException();
    }

    this.key = key;
    this.notAfter = notAfter; 
    this.dirName = dirName;
  }
  
  /**
    *
    */
  public String getKey() {
    return key;
  }
  
  /**
    *
    */
  public UtcTime getNotAfter() {
    return notAfter;
  }

  /**
    *
    */
  public String getDirName() {
    return dirName;
  }

  /**
    *
    */
  public int compareTo(CacheEntry e) {
    return notAfter.compareTo(e.notAfter);
  }

  public boolean checkValidity() {
    return checkValidity(new UtcTime()); 
  }

  public boolean checkValidity(UtcTime utc) {
    return notAfter.compareTo(utc) >= 0;
  }

  /**
    *
    */
  public String toString() {
    String ret = "[";

    ret += key;
    ret += ",";
    ret += notAfter;
    ret += "]";
    return ret; 
  }

}
