package lbl.akenti.test.certs.elements;

import java.io.IOException;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.text.ParseException;

import junit.framework.TestCase;
import junit.framework.TestSuite;
import junit.framework.Test;

import lbl.akenti.certs.elements.AkentiInputStream;
import lbl.akenti.certs.elements.AkentiOutputStream;
import lbl.akenti.certs.elements.AttributeInfo; 
import lbl.akenti.certs.elements.Condition; 

public class ConditionTestCase extends TestCase {

  /**
    *
    */
  public ConditionTestCase(String name) {
    super(name);
  }  

  /**
    *
    */
  public static Test suite() {
    return new TestSuite(ConditionTestCase.class);
  }

  /**
    */
  public void testCondition() 
    throws IOException, ParseException {
    ByteArrayOutputStream baos = new ByteArrayOutputStream();
    AkentiOutputStream aos = new AkentiOutputStream(baos);
    AttributeInfo ai = new AttributeInfo("CPU", "2"); 
    AttributeInfo[] attrInfos = { ai };
    Condition cond = new Condition("CPU < 2", attrInfos); 

    for (int i = 0; i < 5; ++i) {
      cond.writeObject(aos);
      baos.write(' ');
    }

    aos.close();

    ByteArrayInputStream bais = new ByteArrayInputStream(baos.toByteArray());
    AkentiInputStream ais = new AkentiInputStream(bais);

    for (int i = 0; i < 5; ++i) {
      Condition temp = new Condition(ais);

      assertTrue(temp.getConstraint().equals("CPU < 2"));

      AttributeInfo[] tempAttrInfos = temp.getAttributeInfos(); 

      assertTrue(tempAttrInfos.length == 1);
      assertTrue(tempAttrInfos[0].equals(ai));
    } 
  }
}
