package lbl.akenti.util;

public class Pair {

  private String attr;

  private String value;

  public Pair(String attr, String value) {
    if (attr == null || value == null) {
      throw new IllegalArgumentException();
    }

    this.attr = attr;
    this.value = value;
  }

  public String getAttribute() {
    return attr;
  }

  public String getValue() {
    return value;
  }

  /**
    */
  public boolean containsAttribute(String attr) {
    return this.attr.equalsIgnoreCase(attr);
  }

  /**
    */
  public boolean containsValue(String value) {
    return this.value.equals(value);
  }

  public boolean equals(Object obj) {
    if (obj.getClass().equals(this.getClass())) {
       Pair pairobj = (Pair) obj;

       return attr.equalsIgnoreCase(pairobj.attr) && value.equals(pairobj.value);
    }

    return false;
  }

  public String toString() {
    StringBuffer sbuf = new StringBuffer();

    sbuf.append(attr);
    sbuf.append("=");
    sbuf.append(value);

    return sbuf.toString();
  }
}
