package lbl.akenti.policyManager.base;

import lbl.akenti.certs.elements.DistinguishedName;
import java.util.HashSet; 

/**
  *
  */
public class GenX509Value {
    private String value;
    private HashSet cas = new HashSet();
   
    /**
      * Creates a new GenX509Value with unknown value.
      */ 
    public GenX509Value() {
      this("?");
    }
    
    /**
      */
    public GenX509Value(String value) {
      if (value == null) {
        throw new IllegalArgumentException();
      }

      this.value = value;
    }

    /**
      */
    public GenCa[] getGenCas() {
      GenCa []temp = new GenCa[cas.size()];

      cas.toArray(temp);
      return temp;
    }
    
    /**
      * XXX
      */
    public DistinguishedName[] getCaDns() {
      GenCa []cas = getGenCas();
      HashSet caDns = new HashSet();

      for (int i = 0; i < cas.length; i++) {
        caDns.add(cas[i].getDistinguishedName());
      }

      DistinguishedName[]temp = new DistinguishedName[caDns.size()];

      caDns.toArray(temp);
      return temp;
    }

    /**
      */
    public boolean hasValue(String value) {
        return value.equals(this.value);
    }

    /** 
      */
    public String getValue() {
        return value;
    }
    
    /**
      */
    public void addGenCa(GenCa ca) {
        cas.add(ca);
    }
    
    /**
      */
    public void addGenCas(GenCa []cas) {
      for (int i = 0; i < cas.length; i++) {
        addGenCa(cas[i]);
      }
    }
    
    /**
      */
    public String toString() {
      return value.toString();
    }
    
    /**
      */
    public int hashCode() {
      return toString().hashCode();
    }
    
    /**
      */
    public String paramString() {
      StringBuffer sb = new StringBuffer();

      sb.append('[');
      sb.append(value);
      sb.append(',');
      sb.append(cas);
      sb.append(']');
      return sb.toString(); 
    }
}
